Bug 1731583 (python-pingouin) - Review Request: python-pingouin - Statistical package for Python
Summary: Review Request: python-pingouin - Statistical package for Python
Keywords:
Status: ASSIGNED
Alias: python-pingouin
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Timothée Floure
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1674101 python-pytest-sugar
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2019-07-19 20:39 UTC by Ankur Sinha (FranciscoD)
Modified: 2019-07-23 12:26 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
timothee.floure: fedora-review?


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Fedora Pagure neuro-sig/NeuroFedora issue 126 None None None 2019-07-19 20:42:10 UTC

Description Ankur Sinha (FranciscoD) 2019-07-19 20:39:17 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-pingouin/python-pingouin.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-pingouin/python-pingouin-0.2.7-1.fc30.src.rpm

Description:
Pingouin is an open-source statistical package written in Python 3 and based on
Pandas and NumPy.

It provides easy-to-grasp functions for computing several statistical
functions:

- ANOVAs: one- and two-ways, repeated measures, mixed, ancova
- Post-hocs tests and pairwise comparisons
- Robust correlations
- Partial correlation, repeated measures correlation and intraclass correlation
- Bayes Factor
- Tests for sphericity, normality and homoscedasticity
- Effect sizes (Cohen's d, Hedges'g, AUC, Glass delta, eta-square...)
- Parametric/bootstrapped confidence intervals around an effect size or a
  correlation coefficient
- Circular statistics
- Linear/logistic regression and mediation analysis

Pingouin is designed for users who want simple yet exhaustive statistical
functions.

Documentation is available at
https://raphaelvallat.github.io/pingouin/build/html/index.html.

Fedora Account System Username: ankursinha

Comment 1 Timothée Floure 2019-07-20 07:16:43 UTC
Package Review
==============

  * Upstream is GPLv3, not BSD: https://github.com/raphaelvallat/pingouin/blob/master/LICENSE
  * The tests under the check section are not run by default and fail if enabled (do not seem related to missing pytest-sugar): https://paste.sr.ht/~fnux/9aa513ec18533e34f405da400ab027636306fb10
  * The doc subpackage ships quite a lot of third-party web assets (such as bootstrap, which is MIT-licensed), which might be a licensing issue. See https://paste.sr.ht/~fnux/ba797c6e6a3ae7ca90835d9e9e7aa06c3fabaddb for details. I do not think we can do much, but I think we have to specify the licenses.
  * The `%{?python_enable_dependency_generator}` is no required for F30+, do you plan to backport this package to F29? (https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_automatically_generated_dependencies)
  * You might want to use the `%pypi_source` macro: https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
althoug
===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Avoid bundling fonts in non-fonts packages.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Rpmlint
-------
Checking: python3-pingouin-0.2.7-1.fc31.noarch.rpm
          python-pingouin-doc-0.2.7-1.fc31.noarch.rpm
          python-pingouin-0.2.7-1.fc31.src.rpm
python3-pingouin.noarch: W: spelling-error %description -l en_US ancova -> cordovan
python3-pingouin.noarch: W: spelling-error %description -l en_US hocs -> hos, chocs, hocks
python3-pingouin.noarch: W: spelling-error %description -l en_US intraclass -> intramuscular
python3-pingouin.noarch: W: spelling-error %description -l en_US sphericity -> spherical
python3-pingouin.noarch: W: spelling-error %description -l en_US homoscedasticity -> homosexuality
python-pingouin.src: W: spelling-error %description -l en_US ancova -> cordovan
python-pingouin.src: W: spelling-error %description -l en_US hocs -> hos, chocs, hocks
python-pingouin.src: W: spelling-error %description -l en_US intraclass -> intramuscular
python-pingouin.src: W: spelling-error %description -l en_US sphericity -> spherical
python-pingouin.src: W: spelling-error %description -l en_US homoscedasticity -> homosexuality
3 packages and 0 specfiles checked; 0 errors, 10 warnings.

Comment 2 Ankur Sinha (FranciscoD) 2019-07-20 07:50:39 UTC
Thanks for the quick review, Timothée. Please let me know if I can review something for you in return. :)

(In reply to Timothée Floure from comment #1)
> Package Review
> ==============
> 
>   * Upstream is GPLv3, not BSD:
> https://github.com/raphaelvallat/pingouin/blob/master/LICENSE

Gah. Sorry---updated.

>   * The tests under the check section are not run by default and fail if
> enabled (do not seem related to missing pytest-sugar):
> https://paste.sr.ht/~fnux/9aa513ec18533e34f405da400ab027636306fb10

A missing BR: pytest-cov. Added it now. I verified in a virtual environment
that all tests pass. I'll enable them as soon as pytest-sugar is approved.

>   * The doc subpackage ships quite a lot of third-party web assets (such as
> bootstrap, which is MIT-licensed), which might be a licensing issue. See
> https://paste.sr.ht/~fnux/ba797c6e6a3ae7ca90835d9e9e7aa06c3fabaddb for
> details. I do not think we can do much, but I think we have to specify the
> licenses.

I added MIT to the license list and included a comment explaining it too.

>   * The `%{?python_enable_dependency_generator}` is no required for F30+, do
> you plan to backport this package to F29?
> (https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/
> #_automatically_generated_dependencies)

Yes. We want to support F29 too.

>   * You might want to use the `%pypi_source` macro:
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/

Unfortunately, the PyPi tar does not contain tests or docs so I must use the github release.

Updated spec/srpm:

Spec URL: https://ankursinha.fedorapeople.org/python-pingouin/python-pingouin.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-pingouin/python-pingouin-0.2.7-1.fc30.src.rpm

Comment 3 Timothée Floure 2019-07-20 11:58:17 UTC
> Thanks for the quick review, Timothée. Please let me know if I can review something for you in return. :)

Not right now but I'll keep it in mind. Thanks!

> Yes. We want to support F29 too.

A conditional and/or a comment would be nice so that an useless macro is not forgotten for the next ten Fedora releases ;-)

> A missing BR: pytest-cov. Added it now. I verified in a virtual environment
that all tests pass. I'll enable them as soon as pytest-sugar is approved.

The pytest-cov issue is fixed but there is a failing test on my side, using your python3-pytest-sugar package: https://paste.sr.ht/~fnux/620bae68a1983798babcc943a726fc0f0d1c64aa

I believe you should remove `Documentation is available at https://raphaelvallat.github.io/pingouin/build/html/index.html.` from the description field: it is not relevant and the link is broken anyway.

Comment 4 Ankur Sinha (FranciscoD) 2019-07-20 12:23:24 UTC
(In reply to Timothée Floure from comment #3)
> > Thanks for the quick review, Timothée. Please let me know if I can review something for you in return. :)
> 
> Not right now but I'll keep it in mind. Thanks!
> 
> > Yes. We want to support F29 too.
> 
> A conditional and/or a comment would be nice so that an useless macro is not
> forgotten for the next ten Fedora releases ;-)

I've added a comment. It won't be forgotten, it already doesn't do anything in F30 and I'm sure it'll be mass-removed when it's not needed :)

> 
> > A missing BR: pytest-cov. Added it now. I verified in a virtual environment
> that all tests pass. I'll enable them as soon as pytest-sugar is approved.
> 
> The pytest-cov issue is fixed but there is a failing test on my side, using
> your python3-pytest-sugar package:
> https://paste.sr.ht/~fnux/620bae68a1983798babcc943a726fc0f0d1c64aa

Odd. I'm not getting it here in the virtual environment . Your error seems to be related to pandas but the version in Fedora is fine. I guess we can wait for python-pytest-sugar to be approved and then test it out with that. Testing it on local machines won't tell us the issue.

$ pytest .
Test session starts (platform: linux, Python 3.7.4, pytest 5.0.1, pytest-sugar 0.9.2)
rootdir: /home/asinha/rpmbuild/SOURCES/pingouin-0.2.7, inifile: setup.cfg
plugins: remotedata-0.3.1, travis-fold-1.3.0, sugar-0.9.2, cov-2.7.1
collecting ...
 pingouin/tests/test_bayesian.py ✓✓✓                   4% ▍
 pingouin/tests/test_circular.py ✓✓✓✓✓✓✓               13% █▍
 pingouin/tests/test_contingency.py ✓✓✓✓               18% █▊
 pingouin/tests/test_correlation.py ✓✓✓✓               23% ██▍
 pingouin/tests/test_distribution.py ✓✓✓✓✓✓            30% ███▏
 pingouin/tests/test_effsize.py ✓✓✓✓✓                  37% ███▋
 pingouin/tests/test_multicomp.py ✓✓✓✓                 42% ████▎
 pingouin/tests/test_multivariate.py ✓✓                44% ████▌
 pingouin/tests/test_nonparametric.py ✓✓✓✓✓✓✓          53% █████▍
 pingouin/tests/test_pairwise.py ✓✓✓✓                  58% █████▉
 pingouin/tests/test_pandas.py ✓                       59% █████▉
 pingouin/tests/test_parametric.py ✓✓✓✓✓✓✓             68% ██████▉
 pingouin/tests/test_plotting.py ✓✓✓✓✓✓                76% ███████▋
 pingouin/tests/test_power.py ✓✓✓✓✓✓                   84% ████████▍
 pingouin/tests/test_regression.py ✓✓✓                 87% ████████▊
 pingouin/tests/test_reliability.py ✓✓                 90% █████████
 pingouin/tests/test_utils.py ✓✓✓✓✓✓✓✓                 100% ██████████
============================================================================================================== warnings summary ==============================================================================================================
pingouin/tests/test_correlation.py::TestCorrelation::test_partial_corr
  /home/asinha/rpmbuild/SOURCES/pingouin-0.2.7/pingouin/utils.py:297: DeprecationWarning: Using or importing the ABCs from 'collections' instead of from 'collections.abc' is deprecated, and in 3.8 it will stop working
    x_is_iter = isinstance(x, collections.Iterable)

pingouin/tests/test_parametric.py::TestParametric::test_ancova
  /home/asinha/.local/share/virtualenvs/pingouin/lib/python3.7/site-packages/patsy/constraint.py:13: DeprecationWarning: Using or importing the ABCs from 'collections' instead of from 'collections.abc' is deprecated, and in 3.8 it will stop working
    from collections import Mapping

pingouin/tests/test_parametric.py::TestParametric::test_ancova
  /home/asinha/.local/share/virtualenvs/pingouin/lib64/python3.7/importlib/_bootstrap.py:219: RuntimeWarning: numpy.ufunc size changed, may indicate binary incompatibility. Expected 192 from C header, got 216 from PyObject
    return f(*args, **kwds)

-- Docs: https://docs.pytest.org/en/latest/warnings.html

----------- coverage: platform linux, python 3.7.4-final-0 -----------
Name                        Stmts   Miss Branch BrPart  Cover   Missing
-----------------------------------------------------------------------
pingouin/__init__.py           19      0      0      0   100%
pingouin/bayesian.py           67      0     16      0   100%
pingouin/circular.py           86      0     20      0   100%
pingouin/contingency.py        80      0     40      1    99%   351->354
pingouin/correlation.py       222      0     64      1    99%   80->79
pingouin/distribution.py      170      0     56      0   100%
pingouin/effsize.py           174      0     82      1    99%   537->exit
pingouin/multicomp.py          67      0     14      0   100%
pingouin/multivariate.py       76      0     14      2    98%   87->93, 204->212
pingouin/nonparametric.py     121      1     20      1    99%   499, 498->499
pingouin/pairwise.py          276      0    140      0   100%
pingouin/pandas.py             47      0      0      0   100%
pingouin/parametric.py        419      0    101      2    99%   446->450, 892->896
pingouin/plotting.py          244      0     54      2    99%   466->470, 627->631
pingouin/power.py             240      0    112      0   100%
pingouin/regression.py        205      0     76      0   100%
pingouin/reliability.py        41      0     12      0   100%
pingouin/utils.py             135      0     61      1    99%   162->174
-----------------------------------------------------------------------
TOTAL                        2689      1    882     11    99%

========================================================================================================= slowest 10 test durations ==========================================================================================================
5.96s call     pingouin/tests/test_regression.py::TestRegression::test_mediation_analysis
3.80s call     pingouin/tests/test_pairwise.py::TestPairwise::test_pairwise_corr
3.34s call     pingouin/tests/test_plotting.py::TestPlotting::test_plot_skipped_corr
1.42s call     pingouin/tests/test_pairwise.py::TestPairwise::test_pairwise_ttests
1.08s call     pingouin/tests/test_plotting.py::TestPlotting::test_plot_paired
1.00s call     pingouin/tests/test_effsize.py::TestEffsize::test_compute_boot_esci
0.63s call     pingouin/tests/test_parametric.py::TestParametric::test_ancova
0.59s call     pingouin/tests/test_pandas.py::TestParametric::test_pandas
0.43s call     pingouin/tests/test_correlation.py::TestCorrelation::test_corr
0.39s call     pingouin/tests/test_plotting.py::TestPlotting::test_plot_shift

Results (24.24s):
      79 passed



> 
> I believe you should remove `Documentation is available at
> https://raphaelvallat.github.io/pingouin/build/html/index.html.` from the
> description field: it is not relevant and the link is broken anyway.


Removed too.

Updated spec/srpm:
Spec URL: https://ankursinha.fedorapeople.org/python-pingouin/python-pingouin.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-pingouin/python-pingouin-0.2.7-1.fc30.src.rpm

Comment 5 Ankur Sinha (FranciscoD) 2019-07-23 09:12:43 UTC
The latest 0.28 version depends on scipy 1.3.0 so we'll have to wait for the fedora package to be updated.

Comment 6 Timothée Floure 2019-07-23 12:26:32 UTC
Yes. We also have to understand the failing test but the package looks good to me :-) I will approve once those last issues have been fixed.


Note You need to log in before you can comment on or make changes to this bug.